#include <stdlib.h>
#include <fcntl.h> //read()
#include <unistd.h> //write()
#include <string.h> //strlen
#include <vector>

class Cat {
public:
	int weight;
};

Cat* create_cat(int weight) {
	Cat* c = 0;
	return c;
}

int get_weight(Cat* c) { return c->weight; }

int null_pointer() {
	Cat* c = 0;
	return c->weight;
}

int interprocedural_null_pointer() {
	Cat* c = create_cat(11); //source of null is create_cat
	int age = get_weight(c); //sink of null is get_weight
	return age; // source & sink are called from a third procedure
}

void fileNotClosed() {
	int fd = open("test_file.txt", O_WRONLY | O_CREAT | O_TRUNC, 0600);
	if (fd != -1) {
		char buffer[256];
		write(fd, buffer, strlen(buffer));
	}
	// Missing close(fd)
}

void double_free() {
	int* p;
	p = (int*)malloc(sizeof(int));
	free(p);
	free(p); //Double free()
}

void memory_leak() {
	int* p;
	p = (int*)malloc(sizeof(int));
	//missing free(p);
}

void realloc_leak() {
	int *p, *q;
	p = (int*)malloc(sizeof(int));
	q = (int*)realloc(p, sizeof(int) * 42);

	if (q != NULL)
		free(q);
	//missing else branch: if realloc failed (i.e. q == NULL), the original pointer (i.e. p) needs to be freed
}

void buffer_overrun() {
   int *arr = (int*)malloc(sizeof(int)*9);
   if (arr != NULL) {
		 int i;
		 for (i = 0; i < 9; i++) {
		   arr[i] = 0; // safe
		   arr[i+1] = 0; // alarm
		 }
		 free(arr);
   }
}

int empty_vector() {
	const std::vector<int> vec;
	return vec[0]; // Empty vector access reported here
}
